## fcl 0.1.0

=== DESCRIPTION ===
Package: fcl
Title: A Financial Calculator
Version: 0.1.0
Authors@R: c(
    person("Xianying", "Tan", , "shrektan@126.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-6072-3521")),
    person("Raymon", "Mina", , "raymonmina@gmail.com", role = c("ctb"),
           comment = c("find_root.rs, xirr.rs")),
    person(given = "The authors of the dependency Rust crates",
           role = c("ctb"),
           comment = "see inst/AUTHORS file for details")
    )
Maintainer: Xianying Tan <shrektan@126.com>
Description: A financial calculator that provides very fast implementations
    of common financial indicators using 'Rust' code. It includes functions for
    bond-related indicators, such as yield to maturity ('YTM'), modified duration,
    and Macaulay duration, as well as functions for calculating time-weighted
    and money-weighted rates of return (using 'Modified Dietz' method) for multiple portfolios,
    given their market values and profit and loss ('PnL') data. 'fcl' is designed
    to be efficient and accurate for financial analysis and computation. The methods
    used in this package are based on the following references:
    <https://en.wikipedia.org/wiki/Modified_Dietz_method>,
    <https://en.wikipedia.org/wiki/Time-weighted_return>.
URL: https://github.com/shrektan/fcl, https://shrektan.github.io/fcl/
BugReports: https://github.com/shrektan/fcl/issues
SystemRequirements: Cargo (Rust's package manager), rustc
Biarch: true
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.2.3
Suggests: testthat (>= 3.0.0)
Imports: xts, ymd
Config/testthat/edition: 3
Config/rextendr/version: 0.3.1
NeedsCompilation: yes
Packaged: 2023-10-13 14:46:06 UTC; shrektan
Author: Xianying Tan [aut, cre] (<https://orcid.org/0000-0002-6072-3521>),
  Raymon Mina [ctb] (find_root.rs, xirr.rs),
  The authors of the dependency Rust crates [ctb] (see inst/AUTHORS file
    for details)
Repository: CRAN
Date/Publication: 2023-10-13 15:40:02 UTC

## fcl 0.1.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: fcl
 Title: A Financial Calculator
-Version: 0.1.0
+Version: 0.1.1
 Authors@R: c(
     person("Xianying", "Tan", , "shrektan@126.com", role = c("aut", "cre"),
            comment = c(ORCID = "0000-0002-6072-3521")),
@@ -27,16 +27,16 @@
 Biarch: true
 License: MIT + file LICENSE
 Encoding: UTF-8
-RoxygenNote: 7.2.3
+RoxygenNote: 7.3.2
 Suggests: testthat (>= 3.0.0)
 Imports: xts, ymd
 Config/testthat/edition: 3
 Config/rextendr/version: 0.3.1
 NeedsCompilation: yes
-Packaged: 2023-10-13 14:46:06 UTC; shrektan
+Packaged: 2024-08-18 09:31:32 UTC; shrektan
 Author: Xianying Tan [aut, cre] (<https://orcid.org/0000-0002-6072-3521>),
   Raymon Mina [ctb] (find_root.rs, xirr.rs),
   The authors of the dependency Rust crates [ctb] (see inst/AUTHORS file
     for details)
 Repository: CRAN
-Date/Publication: 2023-10-13 15:40:02 UTC
+Date/Publication: 2024-08-23 09:40:02 UTC

## fcl 0.1.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: fcl
 Title: A Financial Calculator
-Version: 0.1.1
+Version: 0.1.2
 Authors@R: c(
     person("Xianying", "Tan", , "shrektan@126.com", role = c("aut", "cre"),
            comment = c(ORCID = "0000-0002-6072-3521")),
@@ -33,10 +33,10 @@
 Config/testthat/edition: 3
 Config/rextendr/version: 0.3.1
 NeedsCompilation: yes
-Packaged: 2024-08-18 09:31:32 UTC; shrektan
+Packaged: 2024-08-23 15:34:07 UTC; shrektan
 Author: Xianying Tan [aut, cre] (<https://orcid.org/0000-0002-6072-3521>),
   Raymon Mina [ctb] (find_root.rs, xirr.rs),
   The authors of the dependency Rust crates [ctb] (see inst/AUTHORS file
     for details)
 Repository: CRAN
-Date/Publication: 2024-08-23 09:40:02 UTC
+Date/Publication: 2024-08-23 16:20:05 UTC

## fcl 0.1.3

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: fcl
 Title: A Financial Calculator
-Version: 0.1.2
+Version: 0.1.3
 Authors@R: c(
     person("Xianying", "Tan", , "shrektan@126.com", role = c("aut", "cre"),
            comment = c(ORCID = "0000-0002-6072-3521")),
@@ -33,10 +33,10 @@
 Config/testthat/edition: 3
 Config/rextendr/version: 0.3.1
 NeedsCompilation: yes
-Packaged: 2024-08-23 15:34:07 UTC; shrektan
+Packaged: 2024-11-26 15:31:35 UTC; shrektan
 Author: Xianying Tan [aut, cre] (<https://orcid.org/0000-0002-6072-3521>),
   Raymon Mina [ctb] (find_root.rs, xirr.rs),
   The authors of the dependency Rust crates [ctb] (see inst/AUTHORS file
     for details)
 Repository: CRAN
-Date/Publication: 2024-08-23 16:20:05 UTC
+Date/Publication: 2024-11-26 23:20:02 UTC

## fcl 0.1.4

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: fcl
 Title: A Financial Calculator
-Version: 0.1.3
+Version: 0.1.4
 Authors@R: c(
     person("Xianying", "Tan", , "shrektan@126.com", role = c("aut", "cre"),
            comment = c(ORCID = "0000-0002-6072-3521")),
@@ -31,12 +31,13 @@
 Suggests: testthat (>= 3.0.0)
 Imports: xts, ymd
 Config/testthat/edition: 3
-Config/rextendr/version: 0.3.1
+Config/rextendr/version: 0.3.1.9001
+Depends: R (>= 4.2)
 NeedsCompilation: yes
-Packaged: 2024-11-26 15:31:35 UTC; shrektan
+Packaged: 2025-04-15 08:10:12 UTC; shrektan
 Author: Xianying Tan [aut, cre] (<https://orcid.org/0000-0002-6072-3521>),
   Raymon Mina [ctb] (find_root.rs, xirr.rs),
   The authors of the dependency Rust crates [ctb] (see inst/AUTHORS file
     for details)
 Repository: CRAN
-Date/Publication: 2024-11-26 23:20:02 UTC
+Date/Publication: 2025-04-15 08:20:02 UTC

## fcl 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(fcl CXX C)

# set the default build type
if (NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release)
endif()

# This shouldn't be necessary, but there has been trouble
# with MSVC being set off, but MSVCXX ON.
if(MSVC OR MSVC90 OR MSVC10)
    set(MSVC ON)
endif (MSVC OR MSVC90 OR MSVC10)

set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
include(CompilerSettings)
include(FCLVersion)

if(MSVC OR IS_ICPC)
  option(FCL_STATIC_LIBRARY "Whether the FCL library should be static rather than shared" ON)
else()
  option(FCL_STATIC_LIBRARY "Whether the FCL library should be static rather than shared" OFF)
endif()

# Whether to enable SSE
option(FCL_USE_SSE "Whether FCL should SSE instructions" OFF)
set(FCL_HAVE_SSE 0)
if(FCL_USE_SSE)
  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(FCL_HAVE_SSE 0) #always disable, for now
    add_definitions(-march=native)
  endif()
  # TODO: do something similar for other compilers
endif()

# Find Octomap (optional)
find_package(PkgConfig QUIET)
set(FCL_HAVE_OCTOMAP 0)
if(PKG_CONFIG_FOUND)
    pkg_check_modules(OCTOMAP QUIET octomap)
endif()
if(NOT OCTOMAP_FOUND)
    # if pkfconfig is not installed, then fall back on more fragile detection
    # of octomap
    find_path(OCTOMAP_INCLUDE_DIRS octomap.h
        PATH_SUFFIXES octomap)
    find_path(OCTOMAP_LIBRARY_DIRS
        ${CMAKE_SHARED_LIBRARY_PREFIX}octomap${CMAKE_SHARED_LIBRARY_SUFFIX})
    if(OCTOMAP_INCLUDE_DIRS AND OCTOMAP_LIBRARY_DIRS)
        set(OCTOMAP_LIBRARIES "octomap;octomath")
    endif()
endif()
if (OCTOMAP_INCLUDE_DIRS AND OCTOMAP_LIBRARY_DIRS)
  include_directories(${OCTOMAP_INCLUDE_DIRS})
  link_directories(${OCTOMAP_LIBRARY_DIRS})
  set(FCL_HAVE_OCTOMAP 1)
  message(STATUS "FCL uses Octomap")
else()
  message(STATUS "FCL does not use Octomap")
endif()

# Find FLANN (optional)
find_package(flann QUIET)
if (FLANN_FOUND)
  set(FCL_HAVE_FLANN 1)
  include_directories(${FLANN_INCLUDE_DIRS})
  link_directories(${FLANN_LIBRARY_DIRS})
  message(STATUS "FCL uses Flann")
else()
  message(STATUS "FCL does not use Flann")
endif()


find_package(tinyxml QUIET)
if (TINYXML_FOUND)
  set(FCL_HAVE_TINYXML 1)
  include_directories(${TINYXML_INCLUDE_DIRS})
  link_directories(${TINYXML_LIBRARY_DIRS})
  message(STATUS "FCL uses tinyxml")
else()
  message(STATUS "FCL does not use tinyxml")
endif()


find_package(Boost COMPONENTS thread date_time filesystem system unit_test_framework REQUIRED)
include_directories(${Boost_INCLUDE_DIR})

if(MSVC)
    add_definitions(-DBOOST_ALL_NO_LIB)
endif()
add_definitions(-DBOOST_TEST_DYN_LINK)

# FCL's own include dir should be at the front of the include path
include_directories(BEFORE "include")

if(PKG_CONFIG_FOUND)
  pkg_check_modules(CCD ccd)
  # check to see if the pkg is installed under the libccd name
  if(NOT CCD_FOUND)
    pkg_check_modules(CCD libccd)
  endif()
endif()

if(NOT CCD_FOUND)
    # if pkfconfig is not installed, then fall back on more fragile detection
    # of ccd
    find_path(CCD_INCLUDE_DIRS ccd.h
        PATH_SUFFIXES ccd)
    find_path(CCD_LIBRARY_DIRS
        ${CMAKE_SHARED_LIBRARY_PREFIX}ccd${CMAKE_SHARED_LIBRARY_SUFFIX})
    if(CCD_INCLUDE_DIRS AND CCD_LIBRARY_DIRS)
        set(CCD_LIBRARIES "ccd")
    else()
        message(FATAL_ERROR "Libccd is required by FCL")
    endif()
endif()
include_directories(${CCD_INCLUDE_DIRS})
link_directories(${CCD_LIBRARY_DIRS})

add_subdirectory(include/fcl)
add_subdirectory(src)

set(pkg_conf_file "${CMAKE_CURRENT_SOURCE_DIR}/fcl.pc")
configure_file("${pkg_conf_file}.in" "${pkg_conf_file}" @ONLY)

install(DIRECTORY include/ DESTINATION include
  FILES_MATCHING PATTERN "*.h" PATTERN "*.hxx"
  PATTERN ".DS_Store" EXCLUDE
)

install(FILES "${pkg_conf_file}" DESTINATION lib/pkgconfig/ COMPONENT pkgconfig)


enable_testing()
add_subdirectory(test)

=== test/CMakeLists.txt ===
macro(add_fcl_test test_name)
  add_executable(${ARGV})
  target_link_libraries(${test_name}
    fcl
    ${Boost_SYSTEM_LIBRARY}
    ${Boost_THREAD_LIBRARY}
    ${Boost_DATE_TIME_LIBRARY}
    ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
  add_test(${test_name} ${EXECUTABLE_OUTPUT_PATH}/${test_name})
endmacro(add_fcl_test)

# configure location of resources
file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/fcl_resources" TEST_RESOURCES_DIR)
if(WIN32)
    # Correct directory separator for Windows
    string(REPLACE "\\" "\\\\" TEST_RESOURCES_DIR ${TEST_RESOURCES_DIR})
endif(WIN32)
configure_file("${TEST_RESOURCES_DIR}/config.h.in" "${TEST_RESOURCES_DIR}/config.h")

include_directories(.)

add_fcl_test(test_fcl_collision test_fcl_collision.cpp test_fcl_utility.cpp)
add_fcl_test(test_fcl_distance test_fcl_distance.cpp test_fcl_utility.cpp)
add_fcl_test(test_fcl_geometric_shapes test_fcl_geometric_shapes.cpp test_fcl_utility.cpp)
add_fcl_test(test_fcl_broadphase test_fcl_broadphase.cpp test_fcl_utility.cpp)
add_fcl_test(test_fcl_shape_mesh_consistency test_fcl_shape_mesh_consistency.cpp test_fcl_utility.cpp)
add_fcl_test(test_fcl_frontlist test_fcl_frontlist.cpp test_fcl_utility.cpp)
add_fcl_test(test_fcl_math test_fcl_math.cpp test_fcl_utility.cpp)

add_fcl_test(test_fcl_sphere_capsule test_fcl_sphere_capsule.cpp)
add_fcl_test(test_fcl_capsule_capsule test_fcl_capsule_capsule.cpp)
add_fcl_test(test_fcl_simple test_fcl_simple.cpp)
#add_fcl_test(test_fcl_global_penetration test_fcl_global_penetration.cpp libsvm/svm.cpp test_fcl_utility.cpp)

if (FCL_HAVE_OCTOMAP)
  add_fcl_test(test_fcl_octomap test_fcl_octomap.cpp test_fcl_utility.cpp)
endif()

#if (FCL_HAVE_TINYXML)
#  add_executable(test_fcl_xmldata test_fcl_xmldata.cpp test_fcl_utility.cpp libsvm/svm.cpp)
#  target_link_libraries(test_fcl_xmldata
#    fcl
#    ${TINYXML_LIBRARY_DIRS}
#    ${Boost_SYSTEM_LIBRARY}
#    ${Boost_THREAD_LIBRARY}
#    ${Boost_DATE_TIME_LIBRARY}
#    ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
#  add_test(test_fcl_xmldata ${EXECUTABLE_OUTPUT_PATH}/test_fcl_xmldata)
#endif()

=== debian/changelog ===
fcl (0.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #722268)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 28 Mar 2014 02:05:38 +0100

=== debian/control ===
Source: fcl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>, Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Standards-Version: 3.9.5
Section: science
Priority: extra
Build-Depends: debhelper (>= 9), 
               cmake,
               pkg-config,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-test-dev,
               libccd-dev,
               libtinyxml-dev,
               libflann-dev
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/fcl.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/fcl.git
Homepage: http://gamma.cs.unc.edu/FCL/
XS-Testsuite: autopkgtest

Package: libfcl0
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible Collision Library - shared library
 FCL is a collision and proximity library that integrates several techniques for
 fast and accurate collision checking and proximity computation. Tje library is
 based on hierarchical representations and designed to perform multiple
 proximity queries on different model representations. The set of queries
 includes discrete collision detection, continuous collision detection,
 separation distance computation and penetration depth estimation. The input
 models may correspond to triangulated rigid or deformable models and
 articulated models.

Package: libfcl-dev
Architecture: any
Section: libdevel
Depends: pkg-config,
         libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libboost-test-dev,
         libccd-dev,
         libtinyxml-dev,
         libflann-dev,
	 libfcl0 (= ${binary:Version}),
	 ${misc:Depends}
Description: Flexible Collision Library - development files
 FCL is a collision and proximity library that integrates several techniques for
 fast and accurate collision checking and proximity computation. Tje library is
 based on hierarchical representations and designed to perform multiple
 proximity queries on different model representations. The set of queries
 includes discrete collision detection, continuous collision detection,
 separation distance computation and penetration depth estimation. The input
 models may correspond to triangulated rigid or deformable models and
 articulated models.

Package: libfcl0-dbg
Architecture: any
Section: debug
Depends: libfcl0 (= ${binary:Version}),
         ${misc:Depends}
Description: Flexible Collision Library - debug files
 FCL is a collision and proximity library that integrates several techniques for
 fast and accurate collision checking and proximity computation. Tje library is
 based on hierarchical representations and designed to perform multiple
 proximity queries on different model representations. The set of queries
 includes discrete collision detection, continuous collision detection,
 separation distance computation and penetration depth estimation. The input
 models may correspond to triangulated rigid or deformable models and
 articulated models.

## fcl 0.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -65,22 +65,21 @@
 if (FLANN_FOUND)
   set(FCL_HAVE_FLANN 1)
   include_directories(${FLANN_INCLUDE_DIRS})
-  link_directories(${FLANN_LIBRARY_DIRS})
   message(STATUS "FCL uses Flann")
 else()
   message(STATUS "FCL does not use Flann")
 endif()
 
 
-find_package(tinyxml QUIET)
-if (TINYXML_FOUND)
-  set(FCL_HAVE_TINYXML 1)
-  include_directories(${TINYXML_INCLUDE_DIRS})
-  link_directories(${TINYXML_LIBRARY_DIRS})
-  message(STATUS "FCL uses tinyxml")
-else()
-  message(STATUS "FCL does not use tinyxml")
-endif()
+# find_package(tinyxml QUIET)
+# if (TINYXML_FOUND)
+#   set(FCL_HAVE_TINYXML 1)
+#   include_directories(${TINYXML_INCLUDE_DIRS})
+#   link_directories(${TINYXML_LIBRARY_DIRS})
+#   message(STATUS "FCL uses tinyxml")
+# else()
+#   message(STATUS "FCL does not use tinyxml")
+# endif()
 
 
 find_package(Boost COMPONENTS thread date_time filesystem system unit_test_framework REQUIRED)

=== src/CMakeLists.txt ===
file(GLOB_RECURSE FCL_SOURCE_CODE ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp)
if(FCL_STATIC_LIBRARY)
  add_library(${PROJECT_NAME} STATIC ${FCL_SOURCE_CODE})
else()
  add_library(${PROJECT_NAME} SHARED ${FCL_SOURCE_CODE})
endif()

target_link_libraries(${PROJECT_NAME} ${CCD_LIBRARIES} ${OCTOMAP_LIBRARIES} ${Boost_LIBRARIES})

install(TARGETS ${PROJECT_NAME} ARCHIVE DESTINATION lib/ LIBRARY DESTINATION lib/)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,8 @@
 add_fcl_test(test_fcl_sphere_capsule test_fcl_sphere_capsule.cpp)
 add_fcl_test(test_fcl_capsule_capsule test_fcl_capsule_capsule.cpp)
 add_fcl_test(test_fcl_simple test_fcl_simple.cpp)
+add_fcl_test(test_fcl_capsule_box_1 test_fcl_capsule_box_1.cpp)
+add_fcl_test(test_fcl_capsule_box_2 test_fcl_capsule_box_2.cpp)
 #add_fcl_test(test_fcl_global_penetration test_fcl_global_penetration.cpp libsvm/svm.cpp test_fcl_utility.cpp)
 
 if (FCL_HAVE_OCTOMAP)

=== include/fcl/CMakeLists.txt ===
file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}" VERSION_DIR)
configure_file("${VERSION_DIR}/config.h.in" "${VERSION_DIR}/config.h")

=== debian/changelog ===
fcl (0.3.2-1) unstable; urgency=medium

  * Remove already merged patch
  * Update Standards version
  * Properly define several uploaders
  * Patch 0.3.0 version to use libccd 2.0 currently in SID
  * Missing patch in series files
  * Implement autopkgtest for checking the build
  * Fix priorities
  * Added Testsuite autopkgtest
  * Added watch file
  * Imported Upstream version 0.3.2

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 13 Nov 2015 01:30:09 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: fcl
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>, Leopold Palomo-Avellaneda <leo@alaxarxa.net>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Section: science
-Priority: extra
+Priority: optional
+Testsuite: autopkgtest
 Build-Depends: debhelper (>= 9), 
                cmake,
                pkg-config,
@@ -62,6 +63,7 @@
 Package: libfcl0-dbg
 Architecture: any
 Section: debug
+Priority: extra
 Depends: libfcl0 (= ${binary:Version}),
          ${misc:Depends}
 Description: Flexible Collision Library - debug files

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

.PHONY: override_dh_auto_configure   \
        override_dh_auto_test \
        override_dh_strip

override_dh_auto_configure:
	dh_auto_configure --  \
	    -DCMAKE_INSTALL_PREFIX:PATH=/usr \
	    -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_strip:
	dh_strip -a --dbg-package=libfcl0-dbg

override_dh_auto_test:
	true

%:
	dh $@ --parallel --buildsystem=cmake

## fcl 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

# Use MACOSX_RPATH by default on OS X. This was added in CMake 2.8.12 and
# became default in CMake 3.0. Explicitly setting this policy is necessary to
# suppress a warning in CMake 3.0 and above.
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW)
endif()

project(fcl CXX C)

# set the default build type
if (NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release)
endif()

# Set build type variable
set(FCL_BUILD_TYPE_RELEASE FALSE)
set(FCL_BUILD_TYPE_DEBUG FALSE)

string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPERCASE)
if("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELEASE")
  set(FCL_BUILD_TYPE_RELEASE TRUE)
elseif("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "DEBUG")
  set(FCL_BUILD_TYPE_DEBUG TRUE)
else()
  message(STATUS "CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} unknown. Valid options are: Debug Release")
endif()

# This shouldn't be necessary, but there has been trouble
# with MSVC being set off, but MSVCXX ON.
if(MSVC OR MSVC90 OR MSVC10)
    set(MSVC ON)
endif (MSVC OR MSVC90 OR MSVC10)

set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
include(CompilerSettings)
include(FCLVersion)
include(GNUInstallDirs)

if(MSVC OR IS_ICPC)
  option(FCL_STATIC_LIBRARY "Whether the FCL library should be static rather than shared" ON)
else()
  option(FCL_STATIC_LIBRARY "Whether the FCL library should be static rather than shared" OFF)
endif()

# Whether to enable SSE
option(FCL_USE_SSE "Whether FCL should SSE instructions" OFF)
set(FCL_HAVE_SSE 0)
if(FCL_USE_SSE)
  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(FCL_HAVE_SSE 0) #always disable, for now
    add_definitions(-march=native)
  endif()
  # TODO: do something similar for other compilers
endif()

# Coveralls support
option(FCL_COVERALLS "Turn on coveralls support" OFF)
option(FCL_COVERALLS_UPLOAD "Upload the generated coveralls json" ON)
if(FCL_COVERALLS)
  include(Coveralls)
  coveralls_turn_on_coverage()
endif()

# Find Octomap (optional)
find_package(PkgConfig QUIET)

option(FCL_WITH_OCTOMAP "octomap library support" ON)
set(FCL_HAVE_OCTOMAP 0)
if(FCL_WITH_OCTOMAP)
  if(PKG_CONFIG_FOUND)
      pkg_check_modules(OCTOMAP QUIET octomap)
  endif()
  if(NOT OCTOMAP_FOUND)
      # if pkgconfig is not installed, then fall back on more fragile detection
      # of octomap
      find_path(OCTOMAP_INCLUDE_DIRS octomap.h
          PATH_SUFFIXES octomap)
      find_library(OCTOMAP_LIBRARY_DIRS
          ${CMAKE_SHARED_LIBRARY_PREFIX}octomap${CMAKE_SHARED_LIBRARY_SUFFIX})
      if(OCTOMAP_INCLUDE_DIRS AND OCTOMAP_LIBRARY_DIRS)
          set(OCTOMAP_LIBRARIES "octomap;octomath")
      endif()
  endif()
  if (OCTOMAP_FOUND OR (OCTOMAP_INCLUDE_DIRS AND OCTOMAP_LIBRARY_DIRS))
    string(REPLACE "." ";" VERSION_LIST ${OCTOMAP_VERSION})
    list(GET VERSION_LIST 0 OCTOMAP_MAJOR_VERSION)
    list(GET VERSION_LIST 1 OCTOMAP_MINOR_VERSION)
    list(GET VERSION_LIST 2 OCTOMAP_PATCH_VERSION)
    include_directories(${OCTOMAP_INCLUDE_DIRS})
    link_directories(${OCTOMAP_LIBRARY_DIRS})
    set(FCL_HAVE_OCTOMAP 1)
    message(STATUS "FCL uses Octomap")
  else()
    message(STATUS "FCL does not use Octomap")
  endif()
else()
  message(STATUS "FCL does not use Octomap (as requested)")
endif()


# find_package(tinyxml QUIET)
# if (TINYXML_FOUND)
#   set(FCL_HAVE_TINYXML 1)
#   include_directories(${TINYXML_INCLUDE_DIRS})
#   link_directories(${TINYXML_LIBRARY_DIRS})
#   message(STATUS "FCL uses tinyxml")
# else()
#   message(STATUS "FCL does not use tinyxml")
# endif()


# FCL's own include dir should be at the front of the include path
include_directories(BEFORE "include")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/include")

if(PKG_CONFIG_FOUND)
  pkg_check_modules(CCD ccd)
  # check to see if the pkg is installed under the libccd name
  if(NOT CCD_FOUND)
    pkg_check_modules(CCD libccd)
  endif()
endif()

if(NOT CCD_FOUND)
    # if pkgconfig is not installed, then fall back on more fragile detection
    # of ccd
    find_path(CCD_INCLUDE_DIRS ccd/ccd.h)
    find_library(CCD_LIBRARY
        ${CMAKE_SHARED_LIBRARY_PREFIX}ccd${CMAKE_SHARED_LIBRARY_SUFFIX})
    if(CCD_INCLUDE_DIRS AND CCD_LIBRARY)
        set(CCD_LIBRARIES "${CCD_LIBRARY}")
    else()
        message(FATAL_ERROR "Libccd is required by FCL")
    endif()
endif()
include_directories(${CCD_INCLUDE_DIRS})
link_directories(${CCD_LIBRARY_DIRS})

add_subdirectory(include/fcl)
add_subdirectory(src)

set(pkg_conf_file_in "${CMAKE_CURRENT_SOURCE_DIR}/fcl.pc.in")
set(pkg_conf_file_out "${CMAKE_CURRENT_BINARY_DIR}/fcl.pc")
if(NOT MSVC)
    set(PKG_CFLAGS "-std=c++11")
endif()
configure_file("${pkg_conf_file_in}" "${pkg_conf_file_out}" @ONLY)

install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  FILES_MATCHING PATTERN "*.h" PATTERN "*.hxx"
  PATTERN ".DS_Store" EXCLUDE
)

install(FILES "${pkg_conf_file_out}" DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/ COMPONENT pkgconfig)

# Add uninstall target
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/CMakeModules/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/CMakeModules/cmake_uninstall.cmake")

find_package(Boost COMPONENTS date_time filesystem system unit_test_framework)
option(FCL_BUILD_TESTS "Build FCL tests" ${Boost_FOUND})
if(FCL_BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

=== src/CMakeLists.txt ===
file(GLOB_RECURSE FCL_SOURCE_CODE ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp)
if(FCL_STATIC_LIBRARY)
  add_library(${PROJECT_NAME} STATIC ${FCL_HEADERS} ${FCL_SOURCE_CODE})
else()
  add_library(${PROJECT_NAME} SHARED ${FCL_HEADERS} ${FCL_SOURCE_CODE})
endif()

set_target_properties(${PROJECT_NAME} PROPERTIES
  VERSION ${FCL_VERSION}
  SOVERSION ${FCL_ABI_VERSION})

target_link_libraries(${PROJECT_NAME}
  PUBLIC ${OCTOMAP_LIBRARIES}
  PRIVATE ${CCD_LIBRARIES}
  PRIVATE ${Boost_LIBRARIES})

target_include_directories(${PROJECT_NAME} INTERFACE
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)

export(TARGETS ${PROJECT_NAME}
  FILE "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake")

install(TARGETS ${PROJECT_NAME}
  EXPORT ${PROJECT_NAME}Config
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if(WIN32 AND NOT CYGWIN)
  install(EXPORT ${PROJECT_NAME}Config DESTINATION CMake)
else()
  install(EXPORT ${PROJECT_NAME}Config
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
endif()

# Setup the coveralls target and tell it to gather coverage data for all the lib sources.
if(FCL_COVERALLS)
  coveralls_setup("${FCL_HEADERS};${FCL_SOURCE_CODE};" ${FCL_COVERALLS_UPLOAD})
endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,16 @@
+include_directories(${Boost_INCLUDE_DIR})
+
+if(MSVC)
+    add_definitions(-DBOOST_ALL_NO_LIB)
+endif()
+add_definitions(-DBOOST_TEST_DYN_LINK)
+
+
 macro(add_fcl_test test_name)
   add_executable(${ARGV})
   target_link_libraries(${test_name}
     fcl
+    ${Boost_FILESYSTEM_LIBRARY}
     ${Boost_SYSTEM_LIBRARY}
     ${Boost_THREAD_LIBRARY}
     ${Boost_DATE_TIME_LIBRARY}
@@ -10,14 +19,17 @@
 endmacro(add_fcl_test)
 
 # configure location of resources
-file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/fcl_resources" TEST_RESOURCES_DIR)
+file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/fcl_resources" TEST_RESOURCES_SRC_DIR)
+file(TO_NATIVE_PATH "${CMAKE_CURRENT_BINARY_DIR}/fcl_resources" TEST_RESOURCES_BIN_DIR)
 if(WIN32)
     # Correct directory separator for Windows
-    string(REPLACE "\\" "\\\\" TEST_RESOURCES_DIR ${TEST_RESOURCES_DIR})
+    string(REPLACE "\\" "\\\\" TEST_RESOURCES_SRC_DIR ${TEST_RESOURCES_SRC_DIR})
+    string(REPLACE "\\" "\\\\" TEST_RESOURCES_BIN_DIR ${TEST_RESOURCES_BIN_DIR})
 endif(WIN32)
-configure_file("${TEST_RESOURCES_DIR}/config.h.in" "${TEST_RESOURCES_DIR}/config.h")
+configure_file("${TEST_RESOURCES_SRC_DIR}/config.h.in" "${TEST_RESOURCES_BIN_DIR}/config.h")
 
 include_directories(.)
+include_directories("${CMAKE_CURRENT_BINARY_DIR}")
 
 add_fcl_test(test_fcl_collision test_fcl_collision.cpp test_fcl_utility.cpp)
 add_fcl_test(test_fcl_distance test_fcl_distance.cpp test_fcl_utility.cpp)
@@ -33,6 +45,7 @@
 add_fcl_test(test_fcl_capsule_box_1 test_fcl_capsule_box_1.cpp)
 add_fcl_test(test_fcl_capsule_box_2 test_fcl_capsule_box_2.cpp)
 #add_fcl_test(test_fcl_global_penetration test_fcl_global_penetration.cpp libsvm/svm.cpp test_fcl_utility.cpp)
+add_fcl_test(test_fcl_bvh_models test_fcl_bvh_models.cpp test_fcl_utility.cpp)
 
 if (FCL_HAVE_OCTOMAP)
   add_fcl_test(test_fcl_octomap test_fcl_octomap.cpp test_fcl_utility.cpp)

=== include/fcl/CMakeLists.txt ===
file(GLOB_RECURSE HEADERS            ${CMAKE_CURRENT_SOURCE_DIR}/*.h ${CMAKE_CURRENT_SOURCE_DIR}/*.hxx)
file(GLOB_RECURSE CONFIGURED_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/*.h ${CMAKE_CURRENT_BINARY_DIR}/*.hxx)
set(FCL_HEADERS ${HEADERS} ${CONFIGURED_HEADERS} PARENT_SCOPE)

file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}" FCL_CONFIG_IN_DIR)
file(TO_NATIVE_PATH "${CMAKE_CURRENT_BINARY_DIR}" FCL_CONFIG_OUT_DIR)
configure_file("${FCL_CONFIG_IN_DIR}/config.h.in" "${FCL_CONFIG_OUT_DIR}/config.h")
install(FILES "${FCL_CONFIG_OUT_DIR}/config.h" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/fcl)

=== debian/changelog ===
fcl (0.5.0-5) unstable; urgency=medium
  
  * Drop FCL_HAVE_SSE activation. Upstream clarifies in its 
    CMakeLists: #always disable, for now.
    It justs add -native as parameter to the compiler making it
    not generic. So it's better to disable.
    Closes: #840165
  * Update Source field
  * Added DEB_BUILD_MAINT_OPTIONS activating hardening+bindnow

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 17 Oct 2016 09:04:41 +0200

fcl (0.5.0-4) unstable; urgency=medium

  * Team upload.
  * Enable octomap support on armel and armhf again.

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 14 Sep 2016 10:56:37 +0200

fcl (0.5.0-3) unstable; urgency=medium

  * Team upload
  * Disable octomap where not available (Closes: #836448).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 12 Sep 2016 08:30:12 +0200

fcl (0.5.0-2) unstable; urgency=medium

  [ Anton Gladky ]
  * Do not override binary strip.

  [ Jose Luis Rivero ]
  * Disable geometric shapes patch until upstream fix it for all arches
    (Closes: #834561)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 25 Aug 2016 18:15:59 +0000

fcl (0.5.0-1) unstable; urgency=medium

  [ Jose Luis Rivero ]
  * Update copyright file
  * Imported Upstream version 0.5.0
  * Migrate debian files to new 0.5 library

  [ Anton Gladky ]
  * Remove dbg-binary.

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 21 Jul 2016 16:35:25 +0000

fcl (0.4.0-1) unstable; urgency=medium

  [ Jose Luis Rivero ]
  * Imported Upstream version 0.4.0
  * Enable testing
  * GNUInstallPaths for libraries
  * Update patches
  * Update packages to 0.4 SOVERSION

  [ Anton Gladky ]
  * Apply "cme fix dpkg"

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 10 Feb 2016 00:23:36 +0000

=== debian/control ===
Source: fcl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>,
           Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: science
Testsuite: autopkgtest
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               pkg-config,
               libboost-filesystem-dev,
               libboost-test-dev,
               libccd-dev,
               libtinyxml-dev,
               libflann-dev,
               liboctomap-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/fcl.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/fcl.git
Homepage: http://gamma.cs.unc.edu/FCL/

Package: libfcl0.5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Flexible Collision Library - shared library
 FCL is a collision and proximity library that integrates several techniques for
 fast and accurate collision checking and proximity computation. Tje library is
 based on hierarchical representations and designed to perform multiple
 proximity queries on different model representations. The set of queries
 includes discrete collision detection, continuous collision detection,
 separation distance computation and penetration depth estimation. The input
 models may correspond to triangulated rigid or deformable models and
 articulated models. This package contains the library.

Package: libfcl-dev
Architecture: any
Section: libdevel
Depends: pkg-config,
         libboost-filesystem-dev,
         libboost-test-dev,
         libccd-dev,
         libtinyxml-dev,
         libflann-dev,
         liboctomap-dev,
         libfcl0.5 (= ${binary:Version}),
         ${misc:Depends}
Description: Flexible Collision Library - development files
 FCL is a collision and proximity library that integrates several techniques for
 fast and accurate collision checking and proximity computation. Tje library is
 based on hierarchical representations and designed to perform multiple
 proximity queries on different model representations. The set of queries
 includes discrete collision detection, continuous collision detection,
 separation distance computation and penetration depth estimation. The input
 models may correspond to triangulated rigid or deformable models and
 articulated models. This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
SSE_ENABLED = "FALSE"

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

.PHONY: override_dh_auto_configure     \
        override_dh_auto_test


override_dh_auto_configure:
	dh_auto_configure --  \
	    -DCMAKE_INSTALL_PREFIX:PATH=/usr \
	    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	    -DFCL_WITH_OCTOMAP=True \
	    -DFCL_BUILD_TESTS=True \
	    -DFCL_USE_SSE="${SSE_ENABLED}"

override_dh_auto_test:
	dh_auto_test -- ARGS=-VV

%:
	dh $@ --parallel --buildsystem=cmake

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
     https://github.com/flexible-collision-library/fcl/tags .*/v?(\d\S*)\.tar\.gz
